#include "EsoAcsammm_Header.hpp"
/* Copyright (C) 1991-2017 Free Software Foundation, Inc.
   This file is part of the GNU C Library.

   The GNU C Library is free software; you can redistribute it and/or
   modify it under the terms of the GNU Lesser General Public
   License as published by the Free Software Foundation; either
   version 2.1 of the License, or (at your option) any later version.

   The GNU C Library is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
   Lesser General Public License for more details.

   You should have received a copy of the GNU Lesser General Public
   License along with the GNU C Library; if not, see
   <http://www.gnu.org/licenses/>.  */
/* This header is separate from features.h so that the compiler can
   include it implicitly at the start of every compilation.  It must
   not itself include <features.h> or any other header that includes
   <features.h> because the implicit include comes before any feature
   test macros that may be defined in a source file before it first
   explicitly includes a system header.  GCC knows the name of this
   header in order to preinclude it.  */
/* glibc's intent is to support the IEC 559 math functionality, real
   and complex.  If the GCC (4.9 and later) predefined macros
   specifying compiler intent are available, use them to determine
   whether the overall intent is to support these features; otherwise,
   presume an older compiler has intent to support these features and
   define these macros by default.  */
/* wchar_t uses Unicode 10.0.0.  Version 10.0 of the Unicode Standard is
   synchronized with ISO/IEC 10646:2017, fifth edition, plus
   the following additions from Amendment 1 to the fifth edition:
   - 56 emoji characters
   - 285 hentaigana
   - 3 additional Zanabazar Square characters */
/* We do not support C11 <threads.h>.  */
// ++++++++++++++++++++++++++++++++++
// + Code generated by dcc 1.0      +
// ++++++++++++++++++++++++++++++++++
void a1_res(int bmode_1, double* yy, double* a1_yy, double* der_x, double* a1_der_x, double* x, double* a1_x, double* p, double* a1_p, int* condit, int* lock, int* prev, int& n_x, int& n_p, int& n_c)
#pragma ad indep x a1_x p a1_p a1_yy
#pragma ad dep yy a1_x a1_p
{
   int i_E=0;
   int i_C=0;
   int i__=0;
   int j__=0;
   int k__=0;
   int m__=0;
   int r_i=0;
   int r_j=0;
   int i_a=0;
   int i_b=0;
   int i_loop=0;
   int i__switch=0;
   int i__start=0;
   int i__end=0;
   int i__step=0;
   int while_end=0;
   int i_cont=0;
   int j_cont=0;
   int k_cont=0;
   double var_k10=0;
   double a1_var_k10=0;
   double var_k20=0;
   double a1_var_k20=0;
   double var_E1=0;
   double a1_var_E1=0;
   double var_E2=0;
   double a1_var_E2=0;
   double var_DH1=0;
   double a1_var_DH1=0;
   double var_DH2=0;
   double a1_var_DH2=0;
   double var_R=0;
   double a1_var_R=0;
   double var_cBin=0;
   double a1_var_cBin=0;
   double var_CtoK=0;
   double a1_var_CtoK=0;
   double par_F=0;
   double a1_par_F=0;
   double par_T=0;
   double a1_par_T=0;
   double var_cA=0;
   double a1_var_cA=0;
   double der_var_cA=0;
   double a1_der_var_cA=0;
   double var_cB=0;
   double a1_var_cB=0;
   double der_var_cB=0;
   double a1_der_var_cB=0;
   double var_cC=0;
   double a1_var_cC=0;
   double der_var_cC=0;
   double a1_der_var_cC=0;
   double var_V=0;
   double a1_var_V=0;
   double der_var_V=0;
   double a1_der_var_V=0;
   double var_k1=0;
   double a1_var_k1=0;
   double der_var_k1=0;
   double a1_der_var_k1=0;
   double var_k2=0;
   double a1_var_k2=0;
   double der_var_k2=0;
   double a1_der_var_k2=0;
   double var_Q=0;
   double a1_var_Q=0;
   double der_var_Q=0;
   double a1_der_var_Q=0;
   double var_Obj=0;
   double a1_var_Obj=0;
   double der_var_Obj=0;
   double a1_der_var_Obj=0;
   double var_div0=0;
   double a1_var_div0=0;
   double var_div1=0;
   double a1_var_div1=0;
   double var_div2=0;
   double a1_var_div2=0;
   double var_i_expr=0;
   double a1_var_i_expr=0;
   double var_div3=0;
   double a1_var_div3=0;
   double var_exp4=0;
   double a1_var_exp4=0;
   double var_i_expr5=0;
   double a1_var_i_expr5=0;
   double var_i_expr7=0;
   double a1_var_i_expr7=0;
   double var_div6=0;
   double a1_var_div6=0;
   double var_exp8=0;
   double a1_var_exp8=0;
   double var_i_expr9=0;
   double a1_var_i_expr9=0;
   double var_i_expr11=0;
   double a1_var_i_expr11=0;
   double var_i_expr12=0;
   double a1_var_i_expr12=0;
   double var_div10=0;
   double a1_var_div10=0;
   int i_i=0;
   int i_j=0;
   int i_z=0;
   double v1_0=0;
   double a1_v1_0=0;
   double v1_1=0;
   double a1_v1_1=0;
   double v1_2=0;
   double a1_v1_2=0;
   double v1_3=0;
   double a1_v1_3=0;
   double v1_4=0;
   double a1_v1_4=0;
   double v1_5=0;
   double a1_v1_5=0;
   double v1_6=0;
   double a1_v1_6=0;
   double v1_7=0;
   double a1_v1_7=0;
   double v1_8=0;
   double a1_v1_8=0;
   double v1_9=0;
   double a1_v1_9=0;
   double v1_10=0;
   double a1_v1_10=0;
   double v1_11=0;
   double a1_v1_11=0;
   double v1_12=0;
   double a1_v1_12=0;
   double v1_13=0;
   double a1_v1_13=0;
   double v1_14=0;
   double a1_v1_14=0;
   double v1_15=0;
   double a1_v1_15=0;
   double v1_16=0;
   double a1_v1_16=0;
   double v1_17=0;
   double a1_v1_17=0;
   double v1_18=0;
   double a1_v1_18=0;
   int save_acs_cs_c=0;
   save_acs_cs_c=acs_cs_c;
   if (bmode_1==1) {
      // augmented forward section
      acs_cs[acs_cs_c]=0; acs_cs_c=acs_cs_c+1;
      acs_fds[acs_fds_c]=var_k10; acs_fds_c=acs_fds_c+1; var_k10=4;
      acs_fds[acs_fds_c]=var_k20; acs_fds_c=acs_fds_c+1; var_k20=800;
      acs_fds[acs_fds_c]=var_E1; acs_fds_c=acs_fds_c+1; var_E1=6000;
      acs_fds[acs_fds_c]=var_E2; acs_fds_c=acs_fds_c+1; var_E2=20000;
      acs_fds[acs_fds_c]=var_DH1; acs_fds_c=acs_fds_c+1; var_DH1=0-30000;
      acs_fds[acs_fds_c]=var_DH2; acs_fds_c=acs_fds_c+1; var_DH2=0-10000;
      acs_fds[acs_fds_c]=var_R; acs_fds_c=acs_fds_c+1; var_R=8.31;
      acs_fds[acs_fds_c]=var_cBin; acs_fds_c=acs_fds_c+1; var_cBin=20;
      acs_fds[acs_fds_c]=var_CtoK; acs_fds_c=acs_fds_c+1; var_CtoK=273;
      acs_fds[acs_fds_c]=par_F; acs_fds_c=acs_fds_c+1; par_F=p[0];
      acs_fds[acs_fds_c]=par_T; acs_fds_c=acs_fds_c+1; par_T=p[1];
      acs_fds[acs_fds_c]=var_cA; acs_fds_c=acs_fds_c+1; var_cA=x[0];
      acs_fds[acs_fds_c]=der_var_cA; acs_fds_c=acs_fds_c+1; der_var_cA=der_x[0];
      acs_fds[acs_fds_c]=var_cB; acs_fds_c=acs_fds_c+1; var_cB=x[1];
      acs_fds[acs_fds_c]=der_var_cB; acs_fds_c=acs_fds_c+1; der_var_cB=der_x[1];
      acs_fds[acs_fds_c]=var_cC; acs_fds_c=acs_fds_c+1; var_cC=x[2];
      acs_fds[acs_fds_c]=der_var_cC; acs_fds_c=acs_fds_c+1; der_var_cC=der_x[2];
      acs_fds[acs_fds_c]=var_V; acs_fds_c=acs_fds_c+1; var_V=x[3];
      acs_fds[acs_fds_c]=der_var_V; acs_fds_c=acs_fds_c+1; der_var_V=der_x[3];
      acs_fds[acs_fds_c]=var_k1; acs_fds_c=acs_fds_c+1; var_k1=x[4];
      acs_fds[acs_fds_c]=der_var_k1; acs_fds_c=acs_fds_c+1; der_var_k1=der_x[4];
      acs_fds[acs_fds_c]=var_k2; acs_fds_c=acs_fds_c+1; var_k2=x[5];
      acs_fds[acs_fds_c]=der_var_k2; acs_fds_c=acs_fds_c+1; der_var_k2=der_x[5];
      acs_fds[acs_fds_c]=var_Q; acs_fds_c=acs_fds_c+1; var_Q=x[6];
      acs_fds[acs_fds_c]=der_var_Q; acs_fds_c=acs_fds_c+1; der_var_Q=der_x[6];
      acs_fds[acs_fds_c]=var_Obj; acs_fds_c=acs_fds_c+1; var_Obj=x[7];
      acs_fds[acs_fds_c]=der_var_Obj; acs_fds_c=acs_fds_c+1; der_var_Obj=der_x[7];
      bmode_1=2; // store inputs and run original code
      a1_acs_div(bmode_1,par_F,a1_par_F,var_V,a1_var_V,var_div0,a1_var_div0);
      acs_fds[acs_fds_c]=yy[i_E]; acs_fds_c=acs_fds_c+1; yy[i_E]=der_var_cA-(0-var_k1*var_cA*var_cB-var_div0*var_cA);
      acs_ids[acs_ids_c]=i_E; acs_ids_c=acs_ids_c+1; i_E=i_E+1;
      bmode_1=2; // store inputs and run original code
      a1_acs_div(bmode_1,par_F,a1_par_F,var_V,a1_var_V,var_div1,a1_var_div1);
      acs_fds[acs_fds_c]=yy[i_E]; acs_fds_c=acs_fds_c+1; yy[i_E]=der_var_cB-(0-var_k1*var_cA*var_cB+var_div1*(var_cBin-var_cB));
      acs_ids[acs_ids_c]=i_E; acs_ids_c=acs_ids_c+1; i_E=i_E+1;
      bmode_1=2; // store inputs and run original code
      a1_acs_div(bmode_1,par_F,a1_par_F,var_V,a1_var_V,var_div2,a1_var_div2);
      acs_fds[acs_fds_c]=yy[i_E]; acs_fds_c=acs_fds_c+1; yy[i_E]=der_var_cC-(var_k1*var_cA*var_cB-var_k2*var_cC-var_div2*var_cC);
      acs_ids[acs_ids_c]=i_E; acs_ids_c=acs_ids_c+1; i_E=i_E+1;
      acs_fds[acs_fds_c]=yy[i_E]; acs_fds_c=acs_fds_c+1; yy[i_E]=der_var_V-(par_F);
      acs_ids[acs_ids_c]=i_E; acs_ids_c=acs_ids_c+1; i_E=i_E+1;
      acs_fds[acs_fds_c]=var_i_expr; acs_fds_c=acs_fds_c+1; var_i_expr=(var_R*(par_T+var_CtoK));
      bmode_1=2; // store inputs and run original code
      a1_acs_div(bmode_1,var_E1,a1_var_E1,var_i_expr,a1_var_i_expr,var_div3,a1_var_div3);
      acs_fds[acs_fds_c]=var_i_expr5; acs_fds_c=acs_fds_c+1; var_i_expr5=0-var_div3;
      bmode_1=2; // store inputs and run original code
      a1_acs_exp(bmode_1,var_i_expr5,a1_var_i_expr5,var_exp4,a1_var_exp4);
      acs_fds[acs_fds_c]=yy[i_E]; acs_fds_c=acs_fds_c+1; yy[i_E]=var_k1-(var_k10*var_exp4);
      acs_ids[acs_ids_c]=i_E; acs_ids_c=acs_ids_c+1; i_E=i_E+1;
      acs_fds[acs_fds_c]=var_i_expr7; acs_fds_c=acs_fds_c+1; var_i_expr7=(var_R*(par_T+var_CtoK));
      bmode_1=2; // store inputs and run original code
      a1_acs_div(bmode_1,var_E2,a1_var_E2,var_i_expr7,a1_var_i_expr7,var_div6,a1_var_div6);
      acs_fds[acs_fds_c]=var_i_expr9; acs_fds_c=acs_fds_c+1; var_i_expr9=0-var_div6;
      bmode_1=2; // store inputs and run original code
      a1_acs_exp(bmode_1,var_i_expr9,a1_var_i_expr9,var_exp8,a1_var_exp8);
      acs_fds[acs_fds_c]=yy[i_E]; acs_fds_c=acs_fds_c+1; yy[i_E]=var_k2-(var_k20*var_exp8);
      acs_ids[acs_ids_c]=i_E; acs_ids_c=acs_ids_c+1; i_E=i_E+1;
      acs_fds[acs_fds_c]=var_i_expr11; acs_fds_c=acs_fds_c+1; var_i_expr11=(0-var_DH1*var_k1*var_cA*var_cB*var_V-var_DH2*var_k2*var_cC*var_V);
      acs_fds[acs_fds_c]=var_i_expr12; acs_fds_c=acs_fds_c+1; var_i_expr12=100000;
      bmode_1=2; // store inputs and run original code
      a1_acs_div(bmode_1,var_i_expr11,a1_var_i_expr11,var_i_expr12,a1_var_i_expr12,var_div10,a1_var_div10);
      acs_fds[acs_fds_c]=yy[i_E]; acs_fds_c=acs_fds_c+1; yy[i_E]=var_Q-(var_div10);
      acs_ids[acs_ids_c]=i_E; acs_ids_c=acs_ids_c+1; i_E=i_E+1;
      acs_fds[acs_fds_c]=yy[i_E]; acs_fds_c=acs_fds_c+1; yy[i_E]=var_Obj-(0-var_cC*var_V);
      acs_ids[acs_ids_c]=i_E; acs_ids_c=acs_ids_c+1; i_E=i_E+1;
      acs_ids[acs_ids_c]=n_c; acs_ids_c=acs_ids_c+1; n_c=i_C;
      // For the case you need the actual function value at the end of the forward section, use this mode for storing it.
      // reverse section
      while (acs_cs_c>save_acs_cs_c) {
            acs_cs_c=acs_cs_c-1;
            if (acs_cs[acs_cs_c]==0) {
              acs_ids_c=acs_ids_c-1; n_c=acs_ids[acs_ids_c];
              acs_ids_c=acs_ids_c-1; i_E=acs_ids[acs_ids_c];
              acs_fds_c=acs_fds_c-1; yy[i_E]=acs_fds[acs_fds_c];
              v1_0=var_Obj;
              v1_1=var_cC;
              v1_2=var_V;
              v1_3=v1_1*v1_2;
              v1_4=-v1_3;
              v1_5=v1_4;
              v1_6=v1_0-v1_5;
              a1_v1_6=a1_yy[i_E]; a1_yy[i_E]=0;
              a1_v1_0=a1_v1_6; a1_v1_5=0-a1_v1_6;
              a1_v1_4=a1_v1_5;
              a1_v1_3=-a1_v1_4;
              a1_v1_1=v1_2*a1_v1_3; a1_v1_2=v1_1*a1_v1_3;
              a1_var_V=a1_var_V+a1_v1_2;
              a1_var_cC=a1_var_cC+a1_v1_1;
              a1_var_Obj=a1_var_Obj+a1_v1_0;
              acs_ids_c=acs_ids_c-1; i_E=acs_ids[acs_ids_c];
              acs_fds_c=acs_fds_c-1; yy[i_E]=acs_fds[acs_fds_c];
              v1_0=var_Q;
              v1_1=var_div10;
              v1_2=v1_1;
              v1_3=v1_0-v1_2;
              a1_v1_3=a1_yy[i_E]; a1_yy[i_E]=0;
              a1_v1_0=a1_v1_3; a1_v1_2=0-a1_v1_3;
              a1_v1_1=a1_v1_2;
              a1_var_div10=a1_var_div10+a1_v1_1;
              a1_var_Q=a1_var_Q+a1_v1_0;
              bmode_1=1; // restore and joint reversal
          a1_acs_div(bmode_1,var_i_expr11,a1_var_i_expr11,var_i_expr12,a1_var_i_expr12,var_div10,a1_var_div10);
              acs_fds_c=acs_fds_c-1; var_i_expr12=acs_fds[acs_fds_c];
              v1_0=100000;
              a1_v1_0=a1_var_i_expr12; a1_var_i_expr12=0;
              acs_fds_c=acs_fds_c-1; var_i_expr11=acs_fds[acs_fds_c];
              v1_0=var_DH1;
              v1_1=var_k1;
              v1_2=v1_0*v1_1;
              v1_3=var_cA;
              v1_4=v1_2*v1_3;
              v1_5=var_cB;
              v1_6=v1_4*v1_5;
              v1_7=var_V;
              v1_8=v1_6*v1_7;
              v1_9=-v1_8;
              v1_10=var_DH2;
              v1_11=var_k2;
              v1_12=v1_10*v1_11;
              v1_13=var_cC;
              v1_14=v1_12*v1_13;
              v1_15=var_V;
              v1_16=v1_14*v1_15;
              v1_17=v1_9-v1_16;
              v1_18=v1_17;
              a1_v1_18=a1_var_i_expr11; a1_var_i_expr11=0;
              a1_v1_17=a1_v1_18;
              a1_v1_9=a1_v1_17; a1_v1_16=0-a1_v1_17;
              a1_v1_14=v1_15*a1_v1_16; a1_v1_15=v1_14*a1_v1_16;
              a1_var_V=a1_var_V+a1_v1_15;
              a1_v1_12=v1_13*a1_v1_14; a1_v1_13=v1_12*a1_v1_14;
              a1_var_cC=a1_var_cC+a1_v1_13;
              a1_v1_10=v1_11*a1_v1_12; a1_v1_11=v1_10*a1_v1_12;
              a1_var_k2=a1_var_k2+a1_v1_11;
              a1_var_DH2=a1_var_DH2+a1_v1_10;
              a1_v1_8=-a1_v1_9;
              a1_v1_6=v1_7*a1_v1_8; a1_v1_7=v1_6*a1_v1_8;
              a1_var_V=a1_var_V+a1_v1_7;
              a1_v1_4=v1_5*a1_v1_6; a1_v1_5=v1_4*a1_v1_6;
              a1_var_cB=a1_var_cB+a1_v1_5;
              a1_v1_2=v1_3*a1_v1_4; a1_v1_3=v1_2*a1_v1_4;
              a1_var_cA=a1_var_cA+a1_v1_3;
              a1_v1_0=v1_1*a1_v1_2; a1_v1_1=v1_0*a1_v1_2;
              a1_var_k1=a1_var_k1+a1_v1_1;
              a1_var_DH1=a1_var_DH1+a1_v1_0;
              acs_ids_c=acs_ids_c-1; i_E=acs_ids[acs_ids_c];
              acs_fds_c=acs_fds_c-1; yy[i_E]=acs_fds[acs_fds_c];
              v1_0=var_k2;
              v1_1=var_k20;
              v1_2=var_exp8;
              v1_3=v1_1*v1_2;
              v1_4=v1_3;
              v1_5=v1_0-v1_4;
              a1_v1_5=a1_yy[i_E]; a1_yy[i_E]=0;
              a1_v1_0=a1_v1_5; a1_v1_4=0-a1_v1_5;
              a1_v1_3=a1_v1_4;
              a1_v1_1=v1_2*a1_v1_3; a1_v1_2=v1_1*a1_v1_3;
              a1_var_exp8=a1_var_exp8+a1_v1_2;
              a1_var_k20=a1_var_k20+a1_v1_1;
              a1_var_k2=a1_var_k2+a1_v1_0;
              bmode_1=1; // restore and joint reversal
          a1_acs_exp(bmode_1,var_i_expr9,a1_var_i_expr9,var_exp8,a1_var_exp8);
              acs_fds_c=acs_fds_c-1; var_i_expr9=acs_fds[acs_fds_c];
              v1_0=var_div6;
              v1_1=-v1_0;
              a1_v1_1=a1_var_i_expr9; a1_var_i_expr9=0;
              a1_v1_0=-a1_v1_1;
              a1_var_div6=a1_var_div6+a1_v1_0;
              bmode_1=1; // restore and joint reversal
          a1_acs_div(bmode_1,var_E2,a1_var_E2,var_i_expr7,a1_var_i_expr7,var_div6,a1_var_div6);
              acs_fds_c=acs_fds_c-1; var_i_expr7=acs_fds[acs_fds_c];
              v1_0=var_R;
              v1_1=par_T;
              v1_2=var_CtoK;
              v1_3=v1_1+v1_2;
              v1_4=v1_3;
              v1_5=v1_0*v1_4;
              v1_6=v1_5;
              a1_v1_6=a1_var_i_expr7; a1_var_i_expr7=0;
              a1_v1_5=a1_v1_6;
              a1_v1_0=v1_4*a1_v1_5; a1_v1_4=v1_0*a1_v1_5;
              a1_v1_3=a1_v1_4;
              a1_v1_1=a1_v1_3; a1_v1_2=a1_v1_3;
              a1_var_CtoK=a1_var_CtoK+a1_v1_2;
              a1_par_T=a1_par_T+a1_v1_1;
              a1_var_R=a1_var_R+a1_v1_0;
              acs_ids_c=acs_ids_c-1; i_E=acs_ids[acs_ids_c];
              acs_fds_c=acs_fds_c-1; yy[i_E]=acs_fds[acs_fds_c];
              v1_0=var_k1;
              v1_1=var_k10;
              v1_2=var_exp4;
              v1_3=v1_1*v1_2;
              v1_4=v1_3;
              v1_5=v1_0-v1_4;
              a1_v1_5=a1_yy[i_E]; a1_yy[i_E]=0;
              a1_v1_0=a1_v1_5; a1_v1_4=0-a1_v1_5;
              a1_v1_3=a1_v1_4;
              a1_v1_1=v1_2*a1_v1_3; a1_v1_2=v1_1*a1_v1_3;
              a1_var_exp4=a1_var_exp4+a1_v1_2;
              a1_var_k10=a1_var_k10+a1_v1_1;
              a1_var_k1=a1_var_k1+a1_v1_0;
              bmode_1=1; // restore and joint reversal
          a1_acs_exp(bmode_1,var_i_expr5,a1_var_i_expr5,var_exp4,a1_var_exp4);
              acs_fds_c=acs_fds_c-1; var_i_expr5=acs_fds[acs_fds_c];
              v1_0=var_div3;
              v1_1=-v1_0;
              a1_v1_1=a1_var_i_expr5; a1_var_i_expr5=0;
              a1_v1_0=-a1_v1_1;
              a1_var_div3=a1_var_div3+a1_v1_0;
              bmode_1=1; // restore and joint reversal
          a1_acs_div(bmode_1,var_E1,a1_var_E1,var_i_expr,a1_var_i_expr,var_div3,a1_var_div3);
              acs_fds_c=acs_fds_c-1; var_i_expr=acs_fds[acs_fds_c];
              v1_0=var_R;
              v1_1=par_T;
              v1_2=var_CtoK;
              v1_3=v1_1+v1_2;
              v1_4=v1_3;
              v1_5=v1_0*v1_4;
              v1_6=v1_5;
              a1_v1_6=a1_var_i_expr; a1_var_i_expr=0;
              a1_v1_5=a1_v1_6;
              a1_v1_0=v1_4*a1_v1_5; a1_v1_4=v1_0*a1_v1_5;
              a1_v1_3=a1_v1_4;
              a1_v1_1=a1_v1_3; a1_v1_2=a1_v1_3;
              a1_var_CtoK=a1_var_CtoK+a1_v1_2;
              a1_par_T=a1_par_T+a1_v1_1;
              a1_var_R=a1_var_R+a1_v1_0;
              acs_ids_c=acs_ids_c-1; i_E=acs_ids[acs_ids_c];
              acs_fds_c=acs_fds_c-1; yy[i_E]=acs_fds[acs_fds_c];
              v1_0=der_var_V;
              v1_1=par_F;
              v1_2=v1_1;
              v1_3=v1_0-v1_2;
              a1_v1_3=a1_yy[i_E]; a1_yy[i_E]=0;
              a1_v1_0=a1_v1_3; a1_v1_2=0-a1_v1_3;
              a1_v1_1=a1_v1_2;
              a1_par_F=a1_par_F+a1_v1_1;
              a1_der_var_V=a1_der_var_V+a1_v1_0;
              acs_ids_c=acs_ids_c-1; i_E=acs_ids[acs_ids_c];
              acs_fds_c=acs_fds_c-1; yy[i_E]=acs_fds[acs_fds_c];
              v1_0=der_var_cC;
              v1_1=var_k1;
              v1_2=var_cA;
              v1_3=v1_1*v1_2;
              v1_4=var_cB;
              v1_5=v1_3*v1_4;
              v1_6=var_k2;
              v1_7=var_cC;
              v1_8=v1_6*v1_7;
              v1_9=v1_5-v1_8;
              v1_10=var_div2;
              v1_11=var_cC;
              v1_12=v1_10*v1_11;
              v1_13=v1_9-v1_12;
              v1_14=v1_13;
              v1_15=v1_0-v1_14;
              a1_v1_15=a1_yy[i_E]; a1_yy[i_E]=0;
              a1_v1_0=a1_v1_15; a1_v1_14=0-a1_v1_15;
              a1_v1_13=a1_v1_14;
              a1_v1_9=a1_v1_13; a1_v1_12=0-a1_v1_13;
              a1_v1_10=v1_11*a1_v1_12; a1_v1_11=v1_10*a1_v1_12;
              a1_var_cC=a1_var_cC+a1_v1_11;
              a1_var_div2=a1_var_div2+a1_v1_10;
              a1_v1_5=a1_v1_9; a1_v1_8=0-a1_v1_9;
              a1_v1_6=v1_7*a1_v1_8; a1_v1_7=v1_6*a1_v1_8;
              a1_var_cC=a1_var_cC+a1_v1_7;
              a1_var_k2=a1_var_k2+a1_v1_6;
              a1_v1_3=v1_4*a1_v1_5; a1_v1_4=v1_3*a1_v1_5;
              a1_var_cB=a1_var_cB+a1_v1_4;
              a1_v1_1=v1_2*a1_v1_3; a1_v1_2=v1_1*a1_v1_3;
              a1_var_cA=a1_var_cA+a1_v1_2;
              a1_var_k1=a1_var_k1+a1_v1_1;
              a1_der_var_cC=a1_der_var_cC+a1_v1_0;
              bmode_1=1; // restore and joint reversal
          a1_acs_div(bmode_1,par_F,a1_par_F,var_V,a1_var_V,var_div2,a1_var_div2);
              acs_ids_c=acs_ids_c-1; i_E=acs_ids[acs_ids_c];
              acs_fds_c=acs_fds_c-1; yy[i_E]=acs_fds[acs_fds_c];
              v1_0=der_var_cB;
              v1_1=var_k1;
              v1_2=var_cA;
              v1_3=v1_1*v1_2;
              v1_4=var_cB;
              v1_5=v1_3*v1_4;
              v1_6=-v1_5;
              v1_7=var_div1;
              v1_8=var_cBin;
              v1_9=var_cB;
              v1_10=v1_8-v1_9;
              v1_11=v1_10;
              v1_12=v1_7*v1_11;
              v1_13=v1_6+v1_12;
              v1_14=v1_13;
              v1_15=v1_0-v1_14;
              a1_v1_15=a1_yy[i_E]; a1_yy[i_E]=0;
              a1_v1_0=a1_v1_15; a1_v1_14=0-a1_v1_15;
              a1_v1_13=a1_v1_14;
              a1_v1_6=a1_v1_13; a1_v1_12=a1_v1_13;
              a1_v1_7=v1_11*a1_v1_12; a1_v1_11=v1_7*a1_v1_12;
              a1_v1_10=a1_v1_11;
              a1_v1_8=a1_v1_10; a1_v1_9=0-a1_v1_10;
              a1_var_cB=a1_var_cB+a1_v1_9;
              a1_var_cBin=a1_var_cBin+a1_v1_8;
              a1_var_div1=a1_var_div1+a1_v1_7;
              a1_v1_5=-a1_v1_6;
              a1_v1_3=v1_4*a1_v1_5; a1_v1_4=v1_3*a1_v1_5;
              a1_var_cB=a1_var_cB+a1_v1_4;
              a1_v1_1=v1_2*a1_v1_3; a1_v1_2=v1_1*a1_v1_3;
              a1_var_cA=a1_var_cA+a1_v1_2;
              a1_var_k1=a1_var_k1+a1_v1_1;
              a1_der_var_cB=a1_der_var_cB+a1_v1_0;
              bmode_1=1; // restore and joint reversal
          a1_acs_div(bmode_1,par_F,a1_par_F,var_V,a1_var_V,var_div1,a1_var_div1);
              acs_ids_c=acs_ids_c-1; i_E=acs_ids[acs_ids_c];
              acs_fds_c=acs_fds_c-1; yy[i_E]=acs_fds[acs_fds_c];
              v1_0=der_var_cA;
              v1_1=var_k1;
              v1_2=var_cA;
              v1_3=v1_1*v1_2;
              v1_4=var_cB;
              v1_5=v1_3*v1_4;
              v1_6=-v1_5;
              v1_7=var_div0;
              v1_8=var_cA;
              v1_9=v1_7*v1_8;
              v1_10=v1_6-v1_9;
              v1_11=v1_10;
              v1_12=v1_0-v1_11;
              a1_v1_12=a1_yy[i_E]; a1_yy[i_E]=0;
              a1_v1_0=a1_v1_12; a1_v1_11=0-a1_v1_12;
              a1_v1_10=a1_v1_11;
              a1_v1_6=a1_v1_10; a1_v1_9=0-a1_v1_10;
              a1_v1_7=v1_8*a1_v1_9; a1_v1_8=v1_7*a1_v1_9;
              a1_var_cA=a1_var_cA+a1_v1_8;
              a1_var_div0=a1_var_div0+a1_v1_7;
              a1_v1_5=-a1_v1_6;
              a1_v1_3=v1_4*a1_v1_5; a1_v1_4=v1_3*a1_v1_5;
              a1_var_cB=a1_var_cB+a1_v1_4;
              a1_v1_1=v1_2*a1_v1_3; a1_v1_2=v1_1*a1_v1_3;
              a1_var_cA=a1_var_cA+a1_v1_2;
              a1_var_k1=a1_var_k1+a1_v1_1;
              a1_der_var_cA=a1_der_var_cA+a1_v1_0;
              bmode_1=1; // restore and joint reversal
          a1_acs_div(bmode_1,par_F,a1_par_F,var_V,a1_var_V,var_div0,a1_var_div0);
              acs_fds_c=acs_fds_c-1; der_var_Obj=acs_fds[acs_fds_c];
              v1_0=der_x[7];
              a1_v1_0=a1_der_var_Obj; a1_der_var_Obj=0;
              a1_der_x[7]=a1_der_x[7]+a1_v1_0;
              acs_fds_c=acs_fds_c-1; var_Obj=acs_fds[acs_fds_c];
              v1_0=x[7];
              a1_v1_0=a1_var_Obj; a1_var_Obj=0;
              a1_x[7]=a1_x[7]+a1_v1_0;
              acs_fds_c=acs_fds_c-1; der_var_Q=acs_fds[acs_fds_c];
              v1_0=der_x[6];
              a1_v1_0=a1_der_var_Q; a1_der_var_Q=0;
              a1_der_x[6]=a1_der_x[6]+a1_v1_0;
              acs_fds_c=acs_fds_c-1; var_Q=acs_fds[acs_fds_c];
              v1_0=x[6];
              a1_v1_0=a1_var_Q; a1_var_Q=0;
              a1_x[6]=a1_x[6]+a1_v1_0;
              acs_fds_c=acs_fds_c-1; der_var_k2=acs_fds[acs_fds_c];
              v1_0=der_x[5];
              a1_v1_0=a1_der_var_k2; a1_der_var_k2=0;
              a1_der_x[5]=a1_der_x[5]+a1_v1_0;
              acs_fds_c=acs_fds_c-1; var_k2=acs_fds[acs_fds_c];
              v1_0=x[5];
              a1_v1_0=a1_var_k2; a1_var_k2=0;
              a1_x[5]=a1_x[5]+a1_v1_0;
              acs_fds_c=acs_fds_c-1; der_var_k1=acs_fds[acs_fds_c];
              v1_0=der_x[4];
              a1_v1_0=a1_der_var_k1; a1_der_var_k1=0;
              a1_der_x[4]=a1_der_x[4]+a1_v1_0;
              acs_fds_c=acs_fds_c-1; var_k1=acs_fds[acs_fds_c];
              v1_0=x[4];
              a1_v1_0=a1_var_k1; a1_var_k1=0;
              a1_x[4]=a1_x[4]+a1_v1_0;
              acs_fds_c=acs_fds_c-1; der_var_V=acs_fds[acs_fds_c];
              v1_0=der_x[3];
              a1_v1_0=a1_der_var_V; a1_der_var_V=0;
              a1_der_x[3]=a1_der_x[3]+a1_v1_0;
              acs_fds_c=acs_fds_c-1; var_V=acs_fds[acs_fds_c];
              v1_0=x[3];
              a1_v1_0=a1_var_V; a1_var_V=0;
              a1_x[3]=a1_x[3]+a1_v1_0;
              acs_fds_c=acs_fds_c-1; der_var_cC=acs_fds[acs_fds_c];
              v1_0=der_x[2];
              a1_v1_0=a1_der_var_cC; a1_der_var_cC=0;
              a1_der_x[2]=a1_der_x[2]+a1_v1_0;
              acs_fds_c=acs_fds_c-1; var_cC=acs_fds[acs_fds_c];
              v1_0=x[2];
              a1_v1_0=a1_var_cC; a1_var_cC=0;
              a1_x[2]=a1_x[2]+a1_v1_0;
              acs_fds_c=acs_fds_c-1; der_var_cB=acs_fds[acs_fds_c];
              v1_0=der_x[1];
              a1_v1_0=a1_der_var_cB; a1_der_var_cB=0;
              a1_der_x[1]=a1_der_x[1]+a1_v1_0;
              acs_fds_c=acs_fds_c-1; var_cB=acs_fds[acs_fds_c];
              v1_0=x[1];
              a1_v1_0=a1_var_cB; a1_var_cB=0;
              a1_x[1]=a1_x[1]+a1_v1_0;
              acs_fds_c=acs_fds_c-1; der_var_cA=acs_fds[acs_fds_c];
              v1_0=der_x[0];
              a1_v1_0=a1_der_var_cA; a1_der_var_cA=0;
              a1_der_x[0]=a1_der_x[0]+a1_v1_0;
              acs_fds_c=acs_fds_c-1; var_cA=acs_fds[acs_fds_c];
              v1_0=x[0];
              a1_v1_0=a1_var_cA; a1_var_cA=0;
              a1_x[0]=a1_x[0]+a1_v1_0;
              acs_fds_c=acs_fds_c-1; par_T=acs_fds[acs_fds_c];
              v1_0=p[1];
              a1_v1_0=a1_par_T; a1_par_T=0;
              a1_p[1]=a1_p[1]+a1_v1_0;
              acs_fds_c=acs_fds_c-1; par_F=acs_fds[acs_fds_c];
              v1_0=p[0];
              a1_v1_0=a1_par_F; a1_par_F=0;
              a1_p[0]=a1_p[0]+a1_v1_0;
              acs_fds_c=acs_fds_c-1; var_CtoK=acs_fds[acs_fds_c];
              v1_0=273;
              a1_v1_0=a1_var_CtoK; a1_var_CtoK=0;
              acs_fds_c=acs_fds_c-1; var_cBin=acs_fds[acs_fds_c];
              v1_0=20;
              a1_v1_0=a1_var_cBin; a1_var_cBin=0;
              acs_fds_c=acs_fds_c-1; var_R=acs_fds[acs_fds_c];
              v1_0=8.31;
              a1_v1_0=a1_var_R; a1_var_R=0;
              acs_fds_c=acs_fds_c-1; var_DH2=acs_fds[acs_fds_c];
              v1_0=10000;
              v1_1=-v1_0;
              a1_v1_1=a1_var_DH2; a1_var_DH2=0;
              a1_v1_0=-a1_v1_1;
              acs_fds_c=acs_fds_c-1; var_DH1=acs_fds[acs_fds_c];
              v1_0=30000;
              v1_1=-v1_0;
              a1_v1_1=a1_var_DH1; a1_var_DH1=0;
              a1_v1_0=-a1_v1_1;
              acs_fds_c=acs_fds_c-1; var_E2=acs_fds[acs_fds_c];
              v1_0=20000;
              a1_v1_0=a1_var_E2; a1_var_E2=0;
              acs_fds_c=acs_fds_c-1; var_E1=acs_fds[acs_fds_c];
              v1_0=6000;
              a1_v1_0=a1_var_E1; a1_var_E1=0;
              acs_fds_c=acs_fds_c-1; var_k20=acs_fds[acs_fds_c];
              v1_0=800;
              a1_v1_0=a1_var_k20; a1_var_k20=0;
              acs_fds_c=acs_fds_c-1; var_k10=acs_fds[acs_fds_c];
              v1_0=4;
              a1_v1_0=a1_var_k10; a1_var_k10=0;
            }
          }
       }
       if (bmode_1==2) {
          res(yy, der_x, x, p, condit, lock, prev, n_x, n_p, n_c);
       }
}
